import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ComponentListener, ActionListener, Runnable {
    Main() {
        super("ComponentEvent Example");
        Button b = new Button("Hide Me");

        add(b, BorderLayout.CENTER);
        
        // Listen for events.
        b.addActionListener(this);
        addComponentListener(this);

        setSize(100, 100);
        show();
    }

    public void componentResized(ComponentEvent evt) {
        System.out.print("COMPONENT_RESIZED: ");
        System.out.println("new bounds="+evt.getComponent().getBounds());
    }
    public void componentMoved(ComponentEvent evt) {
        System.out.print("COMPONENT_MOVED: ");
        System.out.println("new bounds="+evt.getComponent().getBounds());
    }
    public void componentShown(ComponentEvent evt) {
        System.out.print("COMPONENT_SHOWN: ");
        System.out.println("new visible state=" +
                           evt.getComponent().isVisible());
    }
    public void componentHidden(ComponentEvent evt) {
        System.out.print("COMPONENT_HIDDEN: ");
        System.out.println("new visible state=" +
                           evt.getComponent().isVisible());
    }
    
    // Hide the frame and start the thread.
    public void actionPerformed(ActionEvent evt) {
        setVisible(false);
        (new Thread(this)).start();
    }

    // This thread waits for 2 seconds and then shows the frame.
    public void run() {
        try {
            Thread.sleep(2000);
        } catch (Exception e) {
        }
        // This causes a COMPONENT_MOVED event to be generated even though
        // the frame is not visible.
        setLocation(100, 100);
        setVisible(true);
    }

    public static void main(String args[]) {
        new Main();
    }
}
