import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener, ItemListener {
    List list;
    Choice choice = new Choice();
    Button toggle = new Button("Toggle");

    Main() {
        super("select Example");

        for (int i=0; i<10; i++) {
            choice.addItem("item "+i);
        }

        // Set listeners
        choice.addItemListener(this);
        toggle.addActionListener(this);

        add(choice, BorderLayout.SOUTH); 
        add(toggle, BorderLayout.NORTH); 
        pack();
        show();
    }

    // When button is pushed
    public void actionPerformed(ActionEvent evt) {
        if (choice != null) {
            // Create a list and transfer items to the list.
            list = new List(choice.getItemCount(), false);
            for (int i=0; i<choice.getItemCount(); i++) {
                list.addItem(choice.getItem(i));
                if (i == choice.getSelectedIndex()) {
                    list.select(i);
                }
            }
            // Add list
            list.addItemListener(this);
            add(list, BorderLayout.CENTER);

            // Remove choice
            remove(choice);
            choice = null;
        } else {
            // Create a choice and transfer items to the list.
            choice = new Choice();
            for (int i=0; i<list.getItemCount(); i++) {
                choice.addItem(list.getItem(i));
                if (i == list.getSelectedIndex()) {
                    choice.select(i);
                }
            }
            // Add choice
            choice.addItemListener(this);
            add(choice, BorderLayout.SOUTH);
 
            // Remove list
            remove(list);
            list = null;
        }
        pack();
    }

    // When list or choice is updated
    public void itemStateChanged(ItemEvent evt) {
        repaint();
    }

    static public void main(String[] args) {
        new Main();
    }
}
