import java.awt.*;
import java.io.*;
import java.util.Vector;

class Main extends Frame implements Runnable {
    int dotSize = 30;
    Vector vec = new Vector();

    Main(String filename) {
        super("decode Example");

        try {
            BufferedReader in = 
                new BufferedReader(new InputStreamReader(
                    new FileInputStream(filename)));
            String str;
            while ((str = in.readLine()) != null) {
                vec.addElement(str);
            }
        } catch (IOException e) {
        }

        setSize(200, 200);
        show();
        (new Thread(this)).start();
    }

    public void update(Graphics g) {
        Insets insets = this.getInsets();
        int x = 0, y = 0, rowCount = 0;
        for (int i = 0; i<vec.size(); i++) {
            g.setColor(Color.decode((String)vec.elementAt(i)));
            g.fillOval(insets.left+x-x%dotSize, insets.top+y-y%dotSize, 
                       dotSize, dotSize);
            x += dotSize;
            if (rowCount == 5) {
                y += dotSize;
                x = 0;
                rowCount = 0;
            } else {
                ++rowCount;
            }
        }
    }

    public void run() {
        while (true) {
            try {Thread.sleep(100);} catch (Exception e) {}
            repaint();
        }
    }

    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("java Main <input_file>");
            System.exit(-1);
        }
        new Main(args[0]);
    }
}
