import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

class Main extends Frame { 
    Color fg, originalFg;
    Color bg, originalBg;
    String str;

    Main() {
        super("getColor Example");
        try {
            System.getProperties().load(
                new FileInputStream("properties.txt"));
            System.getProperties().list(System.out);
            fg = originalFg = Color.getColor("text.fg", 0x000000);
            bg = originalBg = Color.getColor("text.bg", Color.white);
            str = System.getProperties().getProperty("text.value");
        } catch (Exception e) {
            e.printStackTrace();
        }

        addMouseListener(new MouseListener());

        setSize(200, 100);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = getInsets();
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;
        Font f = new Font("Helvetica", Font.BOLD, 40);
        FontMetrics fm = g.getFontMetrics(f);

        g.setFont(f);
        g.setColor(bg);
        g.fillRect(insets.left, insets.top, w, h);
        g.setColor(fg);
        g.drawString(str, insets.left + (w-fm.stringWidth(str))/2, 
                          insets.top + (h-fm.getHeight())/2+fm.getAscent());
    }

  // Mouse event listener
  class MouseListener extends MouseAdapter {
    public void mousePressed(MouseEvent evt) {
        // If darkening or brightening either color has no
        // effect, simply swap the colors.
        if (originalFg.brighter().equals(originalFg)
            || originalBg.brighter().equals(originalBg)) {
            fg = originalBg;
            bg = originalFg;
        } else {
            fg = originalFg.brighter();
            bg = originalBg.darker();
        }
        repaint();
    }

    public void mouseReleased(MouseEvent evt) {
        // Restore original colors
        fg = originalFg;
        bg = originalBg;
        repaint();
    }
  }

    public static void main(String[] args) {
        new Main();
    }
}
