import java.awt.*;
import java.awt.image.*;

class Main extends Frame {
    Main(String filename) {
        super("checkImage Example");
        add(new ImageCanvas(getToolkit().getImage(filename)), 
            BorderLayout.CENTER); 
        setSize(300, 300);
        show();
    }

    static public void main(String[] args) {
        if (args.length == 1) {
            new Main(args[0]);
        } else {
            System.err.println("usage: java Main <image file>");
        }
    }
}

class ImageCanvas extends Component implements Runnable {
    int newWidth = 200, newHeight = 200;
    boolean drawScaled;
    Image image;

    ImageCanvas(Image image) {
        this.image = image;
        (new Thread(this)).start();
    }

    public void paint(Graphics g) {
        update(g);
    }
    public void update(Graphics g) {
        if (drawScaled) {
            g.clearRect(0, 0, getSize().width, getSize().height);
            g.drawImage(image, 0, 0, newWidth, newHeight, this);
        } else {
            g.drawImage(image, 0, 0, this);
        }
    }

    public void run() {
        prepareImage(image, newWidth, newHeight, null);
        while (true) {
            int status = checkImage(image, newWidth, newHeight, null);
            if ((status&ImageObserver.ERROR) != 0) {
                System.out.println("Error encountered while scaling image");
                System.exit(1);
            }
            if ((status&ImageObserver.ALLBITS) != 0) {
                drawScaled = true;
                repaint();
                break;
            }
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
            }
        }
    }
}
