import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements Runnable {
    int curX = -100, curY = -100;
    double newX, newY;
    double angle = 0.0;
    double maxX, maxY, minX, minY;
    int figure;
    boolean clearBg = true;

    Main() {
        super("repaint Example");
        setSize(200, 200);
        this.addMouseListener(new MouseEventHandler());
        show();
        (new Thread(this)).start();
    }
    public void update(Graphics g) {
        int dotSize = 10;
        Insets insets = getInsets();
        int x = insets.left, y = insets.top;
        int w = getSize().width-insets.left-insets.right-dotSize;
        int h = getSize().height-insets.top-insets.bottom-dotSize;

        if (clearBg) {
            g.clearRect(x, y, getSize().width, getSize().height);
            curX = curY = -100;
            clearBg = false;
        } else {
            g.setColor(Color.red);
            g.fillOval(x+curX, y+curY, dotSize, dotSize);
            g.setColor(Color.black);
            curX = (int)(newX*w);        
            curY = (int)(newY*h);
            g.fillOval(x+curX, y+curY, dotSize, dotSize);
        }
    }
    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            figure++;
            angle = 0;
            clearBg = true;
        }
    }
    double plot(double theta) {
        switch (figure % 5) {
        case 0:
            maxX = .8; maxY = .8; minX = -.8; minY = -.8;
            return Math.sin(2 * theta);
        case 1:
            maxX = 1; maxY = 1; minX = -1; minY = -1;
            return Math.cos(2 * theta);
        case 2:
            maxX = 2; maxY = 2; minX = -1.3; minY = -2;
            return Math.cos(theta/2) + 1;
        case 3:
            maxX = 3; maxY = 3; minX = -1.5; minY = -3;
            return 2 * Math.cos(theta/2) + 1;
        case 4:
            maxX = 4; maxY = 4; minX = -2; minY = -4;
            return 3 * Math.cos(theta/2) + 1;
        }
        return 0;
    }
    public void run() {
        while (true) {
            double r = plot(angle);
            newX = (r * Math.cos(angle)-minX)/(maxX-minX);
            newY = (r * Math.sin(angle)-minY)/(maxY-minY);
            repaint();
            try { Thread.sleep(50); } catch (Exception e) {};
            angle += .2;
        }
    }
    static public void main(String[] args) {
        new Main();
    }
}
