import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    BlinkButton blink = new BlinkButton("Blink");
    Main() {
        super("setVisible Example");
        Button ctl = new Button("Show/Hide");
        ctl.addActionListener(this);
        add(ctl, BorderLayout.NORTH); 
        add(blink, BorderLayout.SOUTH); 
        pack();
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        if (blink.isVisible()) {
            blink.setVisible(false);
        } else {
            blink.setVisible(true);
            invalidate();
            validate();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}

class BlinkButton extends Button implements Runnable {
    String label;
    Thread thread;

    BlinkButton(String label) {
        super(label);
        this.label = label;
    }

    public void addNotify() {
        super.addNotify();
        (thread = new Thread(this)).start();
    }

    public void removeNotify() {
	thread = null;
        super.removeNotify();
    }

    public void run() {
        boolean on = false;
        while (thread == Thread.currentThread()) {
	    if (on) {
		setLabel(label);
	    } else {
		setLabel("");
	    }
	    on = !on;
            try {
                Thread.sleep(1000);
            } catch (Exception e) {
            }
        }
    }
}
