import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements Runnable {
    int curX, curY;

    Main() {
        super("getType Example");
        setSize(200, 200);

        this.addMouseListener(new MouseEventListener());
        show();
        (new Thread(this)).start();
    }

    public void update(Graphics g) {
        g.fillOval(curX, curY, 20, 20);
    }

    public int myCursorType() {
        return getCursor().getType();
    }

    class MouseEventListener extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            if (myCursorType() != Cursor.WAIT_CURSOR) {
                curX = evt.getX();
                curY = evt.getY();
                repaint();
            }
        }
    }

    public void run() {
        while (true) {
            try {
                if (myCursorType() == Cursor.WAIT_CURSOR) {
                    setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
                } else {
                    setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
                }
                Thread.sleep(3000);
            } catch (InterruptedException e) {};
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
