import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    Main() {
        super("Dialog Example");
        Button b;
        add(b = new Button("Modal"), BorderLayout.WEST); 
        b.addActionListener(this);
        add(b = new Button("Modeless"), BorderLayout.EAST); 
        b.addActionListener(this);
        pack();
        show();
    }
    
    public void actionPerformed(ActionEvent evt) {
        String what = evt.getActionCommand();
        if ("Modal".equals(what)) {
            new MainDialog(this, true);
        } else if ("Modeless".equals(what)) {
            new MainDialog(this, false);
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
class MainDialog extends Dialog implements ActionListener {
    // These two integers hold the location of the last window.
    // New windows are created at an offset to the previous one.
    static int offsetX, offsetY;

    MainDialog(Frame frame, boolean modal) {
        super(frame, modal);
        setTitle(isModal() ? "Modal" : "Modeless");
        Button b;
        add(b = new Button("Quit"), BorderLayout.CENTER); 
        b.addActionListener(this);
        offsetX += 20;
        offsetY += 20;
        setLocation(offsetX, offsetY);
        pack();
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        dispose();
    }
}
