import java.awt.*;
class Main extends Frame {
    Main() {
        super("Event example");

        // Menu bar with a menu and menu item.
        MenuBar mb = new MenuBar();
        Menu m = new Menu("Menu");
        m.add("MenuItem");
        m.add(new CheckboxMenuItem("CheckboxMenuItem"));
        mb.add(m);
        setMenuBar(mb);

        setLayout(new GridLayout(0, 3));

        // checkbox, grouped checkbox, label, text field, scrollbar, button
        add(new Checkbox("Checkbox"));
        add(new Checkbox("Checkbox", new CheckboxGroup(), true));
        add(new Label("label"));
        add(new TextField("TextField"));
        add(new Button("Button"));
        add(new MyCanvas());

        // scrollbar 
        Scrollbar sb = new Scrollbar(Scrollbar.HORIZONTAL);
        sb.setValues(50, 50, 0, 100);
        add(sb);

        // choice
        Choice choice = new Choice();
        choice.addItem("Choice");
        choice.addItem("a choice item");
        add(choice);

        // list
        List list = new List();
        list.addItem("List");
        list.addItem("a list item");
        add(list);
        
        // text area
        TextArea textArea = new TextArea("TextArea");
        textArea.resize(100, 50);
        add(textArea);

        pack();
        show();
    }

    public boolean handleEvent(Event evt) {
        if (evt.target instanceof Button) {
            System.out.print("Button");
        } else if (evt.target instanceof Choice) {
            System.out.print("Choice");
        } else if (evt.target instanceof Checkbox) {
            System.out.print("Checkbox");
        } else if (evt.target instanceof CheckboxGroup) {
            System.out.print("CheckboxGroup");
        } else if (evt.target instanceof Label) {
            System.out.print("Label");
        } else if (evt.target instanceof TextField) {
            System.out.print("TextField");
        } else if (evt.target instanceof Scrollbar) {
            System.out.print("Scrollbar");
        } else if (evt.target instanceof Canvas) {
            System.out.print("Canvas");
        } else if (evt.target instanceof List) {
            System.out.print("List");
        } else if (evt.target instanceof TextField) {
            System.out.print("TextField");
        } else if (evt.target instanceof TextArea) {
            System.out.print("TextArea");
        } else if (evt.target instanceof MenuItem) {
            System.out.print("MenuItem");
        } else if (evt.target instanceof Container) {
            System.out.print("Container");
        }
        System.out.print(" ");

        switch (evt.id) {
            case Event.ACTION_EVENT: 
                System.out.print("ACTION_EVENT"); break;
            case Event.GOT_FOCUS:
                System.out.print("GOT_FOCUS"); break;
            case Event.KEY_ACTION:
                System.out.print("KEY_ACTION"); break;
            case Event.KEY_ACTION_RELEASE:
                System.out.print("KEY_ACTION_RELEASE"); break;
            case Event.KEY_PRESS:
                System.out.print("KEY_PRESS"); break;
            case Event.KEY_RELEASE:
                System.out.print("KEY_RELEASE"); break;
            case Event.LIST_DESELECT:
                System.out.print("LIST_DESELECT"); break;
            case Event.LIST_SELECT:
                System.out.print("LIST_SELECT"); break;
            case Event.LOAD_FILE:
                System.out.print("LOAD_FILE"); break;
            case Event.LOST_FOCUS:
                System.out.print("LOST_FOCUS"); break;
            case Event.MOUSE_DOWN:
                System.out.print("MOUSE_DOWN"); break;
            case Event.MOUSE_DRAG:
                System.out.print("MOUSE_DRAG"); break;
            case Event.MOUSE_ENTER:
                System.out.print("MOUSE_ENTER"); break;
            case Event.MOUSE_EXIT:
                System.out.print("MOUSE_EXIT"); break;
            case Event.MOUSE_MOVE:
                System.out.print("MOUSE_MOVE"); break;
            case Event.MOUSE_UP:
                System.out.print("MOUSE_UP"); break;
            case Event.SAVE_FILE:
                System.out.print("SAVE_FILE"); break;
            case Event.SCROLL_ABSOLUTE:
                System.out.print("SCROLL_ABSOLUTE"); break;
            case Event.SCROLL_LINE_DOWN:
                System.out.print("SCROLL_LINE_DOWN"); break;
            case Event.SCROLL_LINE_UP:
                System.out.print("SCROLL_LINE_UP"); break;
            case Event.SCROLL_PAGE_DOWN:
                System.out.print("SCROLL_PAGE_DOWN"); break;
            case Event.SCROLL_PAGE_UP:
                System.out.print("SCROLL_PAGE_UP"); break;
            case Event.WINDOW_DEICONIFY:
                System.out.print("WINDOW_DEICONIFY"); break;
            case Event.WINDOW_DESTROY:
                System.out.print("WINDOW_DESTROY"); break;
            case Event.WINDOW_EXPOSE:
                System.out.print("WINDOW_EXPOSE"); break;
            case Event.WINDOW_ICONIFY:
                System.out.print("WINDOW_ICONIFY"); break;
            case Event.WINDOW_MOVED:
                System.out.print("WINDOW_MOVED"); break;
        }
        System.out.print(" ("+evt.x+" "+evt.y+") w("+evt.when+")");
        System.out.print(" k("+(char)evt.key+") m("+evt.modifiers+")");
        System.out.print(" c("+evt.clickCount+") a("+evt.arg+")");
        System.out.println();
        return false;
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MyCanvas extends Canvas {
    public void paint(Graphics g) {
        FontMetrics fm = g.getFontMetrics();
        g.drawString("Canvas", 
            (size().width-fm.stringWidth("Canvas"))/2, 
	    (size().height-fm.getAscent())/2);
    }
}
