import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Polygon polygon = new Polygon();

    Main() {
        super("drawPolygon Example");

        addMouseListener(new MouseEventHandler());
        addMouseMotionListener(new MouseMotionEventHandler());

        setSize(200, 200);
        show();
    }

    public void paint(Graphics g) {
        g.drawPolygon(polygon);
    }
    
    // The default update method clears the screen which causes 
    // flicker.  This override avoids this.
    public void update(Graphics g) {
        paint(g);
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            polygon.addPoint(evt.getX(), evt.getY());
            repaint();
        }
    }

    class MouseMotionEventHandler extends MouseMotionAdapter {
        public void mouseDragged(MouseEvent evt) {
            polygon.addPoint(evt.getX(), evt.getY());
            repaint();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
