import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    int[] xPoints = new int[100];
    int[] yPoints = new int[100];
    int nPoints = 0;

    Main() {
        super("drawPolyline Example");

        addMouseListener(new MouseEventHandler());
        addMouseMotionListener(new MouseMotionEventHandler());

        setSize(200, 200);
        show();
    }

    public void paint(Graphics g) {
        g.drawPolyline(xPoints, yPoints, nPoints);
    }
    
    // The default update method clears the screen which causes 
    // flicker.  This override avoids this.
    public void update(Graphics g) {
        paint(g);
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            if (nPoints < 100) {
                xPoints[nPoints] = evt.getX();
                yPoints[nPoints] = evt.getY();
                ++nPoints;
            }
            repaint();
        }
    }

    class MouseMotionEventHandler extends MouseMotionAdapter {
        public void mouseDragged(MouseEvent evt) {
            if (nPoints < 100) {
                xPoints[nPoints] = evt.getX();
                yPoints[nPoints] = evt.getY();
                ++nPoints;
            }
            repaint();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
