import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Main() {
        super("drawRoundRect Example");
        add(new MainCanvas(), BorderLayout.CENTER); 
        setSize(150, 80);
        show();
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Component {
    String label = "Round Button";
    boolean down;

    MainCanvas () {
        addMouseListener(new MouseEventHandler());
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            down = true;
            repaint();
        }

        public void mouseReleased(MouseEvent evt) {
            down = false;
            repaint();
        }
    }

    public void paint(Graphics g) {
        int w = getSize().width;
        int h = getSize().height;
        FontMetrics fm = g.getFontMetrics();

        if (down) {
            g.setColor(Color.red);
        } else {
            g.setColor(Color.black);
        }
        g.drawRoundRect(0, 0, w-1, h-1, 20, 20);
        g.drawString(label, (w-fm.stringWidth(label))/2, 
            (h-fm.getHeight())/2+fm.getAscent());
    }
}
