import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ActionListener {
    GridBagLayout gbl = new GridBagLayout();

    Main() {
        super("gridwidth Example");
        setLayout(gbl);
        for (int i=0; i<18; i++) {
            if (i % 6 == 5) {
                makeButton("REMAINDER", GridBagConstraints.REMAINDER);
            } else {
                makeButton("1", 1);
            }
        }
        setSize(300, 300);
        show();
    }

    void makeButton(String label, int w) {
        GridBagConstraints c = new GridBagConstraints();
        Button b = new Button(label);

        c.gridwidth = w;
        c.gridheight = 1;
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1;
        c.weighty = 1;
        gbl.setConstraints(b, c);
        add(b);
        b.addActionListener(this);
    }

    public void actionPerformed(ActionEvent evt) {
        Button b = (Button)evt.getSource();
        GridBagConstraints gbc = gbl.getConstraints(b);

        if (gbc.gridwidth != GridBagConstraints.REMAINDER) {
            if (++gbc.gridwidth > 4) {
                gbc.gridwidth = 1;
            }
            gbl.setConstraints(b, gbc);
            b.setLabel("" + gbc.gridwidth);
            invalidate();
            validate();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
