import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    GridLayout layout = new GridLayout(2, 3);
    Button status;
    Main() {
        super("GridLayout Example");
        setLayout(layout);

	// Create 10 buttons for layout
	for (int i=0; i <10; i++) {
	    add( new Button("Button " + i));
	}

	// Add control buttons
        Button b;
        add(b = new Button("row+"));  // 1
        b.addActionListener(this);
        add(b = new Button("row-"));  // 2
        b.addActionListener(this);
        add(b = new Button("column+"));  // 3
        b.addActionListener(this);
        add(b = new Button("column-"));  // 4
        b.addActionListener(this);
        status = new Button("rows="+layout.getRows() + 
                            ", cols="+layout.getColumns());
        add(status);


        setSize(100, 200);
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        String what = evt.getActionCommand();

        if ("row+".equals(what)) {
            layout.setRows(layout.getRows()+1);
        } else if ("row-".equals(what)) {
	    int min = (layout.getColumns() != 0) ? 0 : 1;
	    layout.setRows(Math.max(min, layout.getRows()-1));
        } else if ("column+".equals(what)) {
            layout.setColumns(layout.getColumns()+1);
        } else if ("column-".equals(what)) {
	    int min = (layout.getRows() != 0) ? 0 : 1;
            layout.setColumns(Math.max(0, layout.getColumns()-1));
        }
        // Update status button
        status.setLabel("rows="+layout.getRows() +
                        ", cols="+layout.getColumns());
        invalidate();
        validate();
    }

    public static void main(String[] args) {
        new Main();
    }
}
