import java.awt.*;
import java.awt.event.*;

public class Main extends Frame {
    Label statusBar = new Label();

    Main() {
        super("Label Example");
        add(statusBar, BorderLayout.SOUTH); 
        addMouseMotionListener(new MouseMotionEventHandler());

        setSize(200, 200);
        show();
    }

    class MouseMotionEventHandler extends MouseMotionAdapter {
        private void updateStatus(MouseEvent evt) {
            String status = "("+evt.getX()+","+evt.getY()+") ";
        
            if (evt.isControlDown()) status += "C";
            if (evt.isShiftDown()) status += "S";
            if (evt.isMetaDown()) status += "M";
            if (evt.isAltDown()) status += "A";
            statusBar.setText(status);
        }
        public void mouseMoved(MouseEvent evt) {
            updateStatus(evt);
        }
        public void mouseDragged(MouseEvent evt) {
            updateStatus(evt);
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
