import java.awt.*;
import java.awt.event.*;

class Main extends Frame 
    implements ActionListener {
    PopupMenu pm = new PopupMenu("Colors");

    Button button = new Button("West");

    Main() {
        super("PopupMenu Example");

        // You can add shortcut but it is ignored for popups
        pm.add(new MenuItem("Red", new MenuShortcut(KeyEvent.VK_R)));
        pm.add("Green");
        pm.add("Blue");
        pm.add("-");
        pm.add("Black");
        pm.add("White");
        add(pm);

        add(button, BorderLayout.WEST);

        // Enable mouse events and listen for action events.
        pm.addActionListener(this);
        enableEvents(AWTEvent.MOUSE_EVENT_MASK|AWTEvent.KEY_EVENT_MASK);

        setSize(150, 150);
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        System.out.println(evt.getActionCommand());
    }

    protected void processMouseEvent(MouseEvent evt) {
        if (evt.isPopupTrigger()) {
            // Illustrates that you can make popup show up in
            // subcomponents, using any coordinates
            pm.show(button, button.getSize().width, 0);
        }
        super.processMouseEvent(evt);
    }
    
    public static void main(String args[]) {
        new Main();
    }
}
