import java.awt.*;
import java.awt.event.*;

class FakeScrollbar extends Component {
    public void paint(Graphics g) {
        int w = getSize().width;
        int h = getSize().height;

        g.setColor(Main.colors[SystemColor.SCROLLBAR]);
        g.fillRect(0, 0, w, h);

        draw3DOutline(g, false, 0, 0, w, h);
        draw3DOutline(g, true, 2, 2, w-4, w-4);
        draw3DOutline(g, true, 2, h-w+2, w-4, w-4);
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(18, Math.max(1, getSize().height));
    }

    // Paint a 3D outline using the system colors.
    public void draw3DOutline(Graphics g, boolean up, 
            int x, int y, int w, int h) {
        Color c1 = Main.colors[SystemColor.CONTROL_LT_HIGHLIGHT];
        Color c2 = Main.colors[SystemColor.CONTROL_HIGHLIGHT];
        Color c3 = Main.colors[SystemColor.CONTROL_SHADOW];
        Color c4 = Main.colors[SystemColor.CONTROL_DK_SHADOW];

        if (!up) {
            c1 = Main.colors[SystemColor.CONTROL_DK_SHADOW];
            c2 = Main.colors[SystemColor.CONTROL_SHADOW];
            c3 = Main.colors[SystemColor.CONTROL_LT_HIGHLIGHT];
            c4 = Main.colors[SystemColor.CONTROL_HIGHLIGHT];
        }

        // Paint outer left and top edge.
        g.setColor(c1);
        g.drawLine(x, y, x+w-1, y);
        g.drawLine(x, y, x, y+h-1);

        // Paint inner left and top edge.
        g.setColor(c2);
        g.drawLine(x+1, y+1, x+w-2, y+1);
        g.drawLine(x+1, y+1, x+1, y+h-2);

        // Paint inner shadow right and bottom edge.
        g.setColor(c3);
        g.drawLine(x+w-2, y+h-2, x+w-2, y+1);
        g.drawLine(x+w-2, y+h-2, x+1, y+h-2);

        // Paint outer shadow right and bottom edge.
        g.setColor(c4);
        g.drawLine(x+w-1, y+h-1, x+w-1, y);
        g.drawLine(x+w-1, y+h-1, x, y+h-1);
    }
}
