import java.awt.*;

class FakeTitleBar extends Component {
    boolean active;

    FakeTitleBar(boolean active) {
        this.active = active;
    }

    public Dimension getPreferredSize() {
        return new Dimension(Math.max(1, getSize().width), 20);
    }

    public void paint(Graphics g) {
        FontMetrics fm = g.getFontMetrics();
        int w = getSize().width;
        int h = getSize().height;

        if (active) {
            // Paint caption background.
            g.setColor(Main.colors[SystemColor.ACTIVE_CAPTION]);
            g.fillRect(0, 0, w, h);

            // Paint window title.
            g.setColor(Main.colors[SystemColor.ACTIVE_CAPTION_TEXT]);
            g.drawString("Active Window", 
                (h-fm.getHeight())/2,
                (h-fm.getHeight())/2+fm.getAscent());
        } else {
            // Paint caption background.
            g.setColor(Main.colors[SystemColor.INACTIVE_CAPTION]);
            g.fillRect(0, 0, w, h);

            // Paint window title.
            g.setColor(Main.colors[SystemColor.INACTIVE_CAPTION_TEXT]);
            g.drawString("Inactive Window", 
                (h-fm.getHeight())/2,
                (h-fm.getHeight())/2+fm.getAscent());
        }
    }
}
