import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    TextField tfSearch = new TextField();
    TextField tfReplace = new TextField();
    TextArea ta = new TextArea(10, 40);

    Main() {
        super("replaceRange Example");
        Panel southPanel = new Panel(new GridLayout(2, 1));
        Panel p = new Panel(new BorderLayout());

        p.add(new Label("Search:"), BorderLayout.WEST);
        p.add(tfSearch, BorderLayout.CENTER);

        southPanel.add(p);

        p = new Panel(new BorderLayout());
        p.add(new Label("Replace:"), BorderLayout.WEST);
        p.add(tfReplace, BorderLayout.CENTER);
        southPanel.add(p);

        add(ta, BorderLayout.CENTER);
        add(southPanel, BorderLayout.SOUTH);

        // Add listeners for search and replace text fields
        tfReplace.addActionListener(this);
        tfSearch.addActionListener(this);

        pack();
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        String str = tfSearch.getText();
        int s = ta.getText().indexOf(str, ta.getSelectionStart());

        if (s < 0 && ta.getSelectionStart() > 0) {
            //  Let's try from the beginning.
            s = ta.getText().indexOf(str, 0);
        }
        if (s >= 0) {
            String strRep = tfReplace.getText();
            ta.replaceRange(strRep, s, s + str.length());
            ta.select(s + strRep.length(), s + strRep.length());
            ta.requestFocus();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
