import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    PopupWindow pm = null;
    Main() {
        super("Window Example");

        // Install listener
        this.addMouseListener(new MouseEventHandler());

        setSize(100, 100);
        show();
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            Rectangle r = getBounds();
            int x = evt.getX();
            int y = evt.getY();

            // Create popup at position of mouse
            pm = new PopupWindow(Main.this);
            pm.setBounds(r.x + x, r.y + y, 100, 50);
            pm.show();
        }

        public void mouseReleased(MouseEvent evt) {
            if (pm != null) {
                // get rid of peer
                pm.dispose();
                pm = null;
            }
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}

class PopupWindow extends Window {
    PopupWindow(Frame f) {
        super(f);
        setBackground(Color.yellow);
    }

    public void paint(Graphics g) {
        FontMetrics fm = g.getFontMetrics();
        String s = "Popup Window";

        g.drawString(s, (getSize().width-fm.stringWidth(s))/2,
                     (getSize().height-fm.getHeight())/2 + fm.getAscent());
    }
}
