import java.awt.*;
import java.awt.event.*;
import java.applet.*;
public class Main extends Applet {
    MyWindow w;

    public void init() {        
        // Find the applet's frame.
        Component f = getParent();
        while (f != null && !(f instanceof Frame)) {
            f = f.getParent();
        }

        w = new MyWindow((Frame)f);
        w.setBounds(0, 0, 200, 200);
        w.show();
    }

    public void start() {
        w.show();
    }

    public void stop() {
        w.setVisible(false);
    }
            
    public void destroy() {
        if (w != null) {
            w.dispose();
            w = null;
        }
    }
}

class MyWindow extends Window {
    MyWindow(Frame frame) {
        super(frame);
        this.addMouseListener(new MouseEventHandler());
    }

    public void paint(Graphics g) {
        FontMetrics fm = g.getFontMetrics();
        String s = getWarningString();
        int w = getSize().width - getInsets().left - getInsets().right;
        int h = getSize().height - getInsets().top - getInsets().bottom;

        if (s != null) {
            g.drawString(s, (w-fm.stringWidth(s))/2,
                (h-fm.getHeight())/2 + fm.getAscent());
        }
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            setVisible(false);
        }
    }
}
