import java.awt.*;

public class TipWindow extends Window {
    String label;
    Font f = new Font("Serif", Font.PLAIN, 14);
    FontMetrics fm;

    public TipWindow(Frame frame) {
        super(frame);

        setFont(f);
        fm = getFontMetrics(f);
    }

    public void setLabel(String label) {
        this.label = label;
        if (label != null) {
            setSize(fm.stringWidth(label), fm.getHeight());
        }
    }

    public void paint(Graphics g) {
        g.setColor(Color.yellow);
        g.fillRect(0, 0, getSize().width, getSize().height);

        g.setColor(Color.black);
        if (label != null) {
            g.drawString(label, (getSize().width - fm.stringWidth(label))/2, 
                (getSize().height - fm.getHeight())/2 + fm.getAscent());
        }
    }

    public Dimension getPreferredSize() {
        return new Dimension(20, 20);
    }
}
