import java.awt.*;
import java.beans.*;

public class Bean extends Canvas {
    float price = 1.49f;

    // Constructor
    public Bean() {
        // A couple of calls to make the bean visible.
        setBackground(Color.pink);
        setSize(50, 50);
    }

    // The price is a bound property.
    public float getPrice() {
        return price;
    }

    public void setPrice(float newPrice) {
        float oldPrice = price;

        price = newPrice;
        pceListeners.firePropertyChange("price", 
            new Float(oldPrice), new Float(newPrice));
    }

    // Create the listener list.
    PropertyChangeSupport pceListeners = 
        new PropertyChangeSupport(this);

    // The listener list wrapper methods.
    public synchronized void addPropertyChangeListener(
                                PropertyChangeListener l) {
        pceListeners.addPropertyChangeListener(l);
    }
    
    public synchronized void removePropertyChangeListener(
                                   PropertyChangeListener l) {
        pceListeners.removePropertyChangeListener(l);
    }
}
/* 
    manifest.txt file:
        Name: Bean.class
        Java-Bean: True
    jar command:
        jar cfm bean.jar manifest.txt Bean.class
*/
