package classexample;

import java.awt.*;
import java.beans.*;

public class Bean extends Panel {
    float price = 1.49f;
    Label l = new Label(""+price);

    public Bean() {
        add(l);
    }

    // The price is a bound and constrained property.
    public float getPrice() {
        return price;
    }

    public void setPrice(float newPrice) {
        float oldPrice = price;

        try {
            vceListeners.fireVetoableChange("price", 
                new Float(oldPrice), new Float(newPrice));

            // No vetos so update the price
            price = newPrice;

            pceListeners.firePropertyChange("price", 
                new Float(oldPrice), new Float(newPrice));
        } catch (PropertyVetoException e) {
            // Don't change the price
        }
        l.setText(""+price);
    }

    // Create the vetoable property change listener list.
    VetoableChangeSupport vceListeners = 
        new VetoableChangeSupport(this);

    // The listener list wrapper methods.
    public synchronized void addVetoableChangeListener(
                                VetoableChangeListener l) {
        vceListeners.addVetoableChangeListener(l);
    }
    public synchronized void removeVetoableChangeListener(
                                VetoableChangeListener l) {
        vceListeners.removeVetoableChangeListener(l);
    }

    // Create the property change listener list.
    PropertyChangeSupport pceListeners = 
        new PropertyChangeSupport(this);

    // The listener list wrapper methods.
    public synchronized void addPropertyChangeListener(
                                PropertyChangeListener l) {
        pceListeners.addPropertyChangeListener(l);
    }
    public synchronized void removePropertyChangeListener(
                                PropertyChangeListener l) {
        pceListeners.removePropertyChangeListener(l);
    }
}
/*
    manifest.txt:
        Name: classexample/Bean.class
        Java-Bean: True

        Name: classexample/BeanPriceListener.class
        Java-Bean: True
    jar command (Solaris):
        jar cfm bean.jar manifest.txt classexample/*.class
    jar command (Windows):
        jar cfm bean.jar manifest.txt classexample\*.class
*/